<?php
//encoding="utf-8"
/*-------[ 网站字符集 ]-------*/
$CONFIG['charset']="utf-8"; //网站字符集

/*-------[ 数据库 ]-------*/
$CONFIG['dbhost']="localhost"; // 数据库主机
$CONFIG['dbport']="3306"; // 数据库端口号
$CONFIG['dbtype']="mysql"; // 数据库类型
$CONFIG['dbname']="oes";  // 数据库名称
$CONFIG['dbuser']="root";    // 数据库用户名
$CONFIG['dbpwd']="admin";  // 数据库密码
$CONFIG['dbcharset']="utf8"; //数据库连接字符集
$CONFIG['pconnect']="1";  // 是否使用持久连接 ( 0=关闭, 1=打开 )

/*-------[ 网站模板 ]-------*/
$CONFIG['admin_templates'] = 'default'; // 后台模板的名称
$CONFIG['app_templates'] = 'default'; // 前台模板的名称


/*-------[ cookie ]-------*/
$CONFIG['cookiedomain']=".localhost"; //cookie 作用域
$CONFIG['cookiepath']="/"; //cookie 作用路径
$CONFIG['cookiepre']="oes_"; //cookie 前缀
$CONFIG['cookietime']="3600"; //cookie 默认的保存时间(秒)

/*-------[ 登录校验key ]-------*/
$CONFIG['authkey']="oes_#2008";//用户登录校验key

/*-------[ 时区 ]-------*/
$CONFIG['timezone']="Etc/GMT-8";  //时区设置（只对php 5.1以上版本有效），Etc/GMT-8 实际表示的是 GMT+8

/*-------[ 图片附件 ]-------*/
$CONFIG['attachment']="data/pictures/"; // 图片附件的位置
$CONFIG['attachment_type']="image/gif,image/pjpeg,image/jpeg,image/png,image/x-png,image/bmp"; // 图片附件类型


/*-------[ 前台头像 ]-------*/
$CONFIG['icon_path']="data/icons/"; // 头像所在的位置,不能以 / 开头
$CONFIG['icon_default_path']="/templates/default/images/app/anonymity_48.gif"; //  默认的头像位置
$CONFIG['icon_width']="120"; // 头像的宽度
$CONFIG['icon_height']="120"; // 头像的高度

/*-------[ 分页数据列表 ]-------*/
$CONFIG['page_size5']=5;	// 分页显示列表数量5条
$CONFIG['page_size10']=10; // 分页显示列表数量10条
$CONFIG['page_size15']=15; // 分页显示列表数量15条
$CONFIG['page_size20']=20; // 分页显示列表数量20条
$CONFIG['page_size30']=30; // 分页显示列表数量30条
$CONFIG['page_link_num']=5; 	// 分页显示列表链接的数量
$CONFIG['page_link_offset']=3; 	// 分页显示列表链接的偏移量

$CONFIG['size_dispaly_1']=20;  			//用户自定义设置显示数量1
$CONFIG['size_dispaly_2']=25; 			//用户自定义设置显示数量2
$CONFIG['size_dispaly_3']=30; 			//用户自定义设置显示数量3


/*-------[ 试题管理 ]-------*/     
$CONFIG['qsn_thumbnail_width']="200"; // 生成缩略图的width
$CONFIG['qsn_thumbnail_height']="250"; // 生成缩略图的height
$CONFIG['qsn_point']=5; 	// 默认分数
$CONFIG['qsn_option_count']=12; 	// 默认选项数量
$CONFIG['qsn_single_count']=4;    // 单选题默认起始数量
$CONFIG['qsn_multi_count']=4; 	   // 多选题默认起始数量

/*-------[ 试卷管理 ]-------*/
$CONFIG['paper_label_tab_count']=5; 			// 显示的试卷页面中,分页显示tab的数量
  
/*-------[ 考试管理 ]-------*/
$CONFIG['exam_type']="030101"; 	// 默认的试卷类型（逐题模式030102，整卷模式030101）
$CONFIG['exam_default_point_type']="030201"; 	// 默认的试卷类型（逐题模式030102，整卷模式030101）
                 
/*-------[ 清理session的时间间隔 ]-------*/ 
$CONFIG['clear_session_time']=60; // 时间格式是秒
$CONFIG['toggle_clear_session']="1"; 		// 关闭session清理

/*-------[ 前台个人管理--考试年份列表 ]-------*/ 
$CONFIG['page_my_exam_year']=5; // 我的考试中年份显示的数量

?>
