DROP TABLE IF EXISTS `t_qsn_attachments`;
CREATE TABLE `t_qsn_attachments` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `a_id` char(12) NOT NULL DEFAULT '0',
  `qsn_item_id` int(5) DEFAULT '0',
  `create_user_id` int(10) NOT NULL,
  `file_name` char(100) NOT NULL,
  `des` varchar(400) DEFAULT NULL,
  `file_type` char(50) NOT NULL,
  `file_size` int(10) NOT NULL DEFAULT '0',
  `attachment` char(100) NOT NULL,
  `isimage` tinyint(1) NOT NULL,
  `create_tm` datetime NOT NULL,
  PRIMARY KEY (`a_id`),
  KEY `idx_qsn_id` (`qsn_id`,`qsn_sub_id`,`a_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_qsn_sub_position`;
CREATE TABLE `t_qsn_sub_position` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_position` int(20) NOT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_qsn_sub_position_import`;
CREATE TABLE `t_qsn_sub_position_import` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_position` int(20) NOT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



