<?php

/*
 *      deom.php
 *	(C)2009-2011 Orivon Inc.
 *  	author @tiger
*/

error_reporting(0);
@set_time_limit(1000);
@set_magic_quotes_runtime(0);

define('Orivon', TRUE);
define('ROOT_PATH', dirname(__FILE__).'/../');

 $option='install_oes';

//demo lock file 
$demolockfile=ROOT_PATH.'./data/demolock.lock';

//storing info about demo in db ,table name
$table_demo='t_demo';
$create_demo_table_sql_file=ROOT_PATH.'./install/data/demo/table.demo.sql';

//copy demo attachment file from directory and to directory
$from_dir=ROOT_PATH.'./install/data/demo/pictures/';
$to_dir=ROOT_PATH.'./data/pictures/';

require ROOT_PATH.'./install/include/install_var.php';
require ROOT_PATH.'./install/include/install_mysql.php';
require ROOT_PATH.'./install/include/install_function.php';
require ROOT_PATH.'./install/include/install_lang.php';

$view_off = getgpc('view_off');
$load =getgpc('action');

define('VIEW_OFF', $view_off ? TRUE : FALSE);

	
//check config文件,make true the /install is in the correct directory and 
//conifg.inc.php be related to the correct db,if not it could be direct to fatal error
if(file_exists(ROOT_PATH.CONFIG)) {
	include ROOT_PATH.CONFIG;
}else{
	show_msg('config_nonexistence', '', 0);
}

if(!class_exists('dbstuff')) {
	show_msg('database_nonexistence', '', 0);
}

/*--------------------first page start---------------------*/	
if(empty($load)){

		show_header();

?>	
				<div class="right_2">
					<p>安装Demo数据</p>
				</div>
				<div class="right_3">
					<div class="demo">
						
							<input type="button" onclick="window.location.href='demo.php?action=load'" value="安装demo数据" >
							<input type="button" onclick="window.location.href='demo.php?action=unload'" value="卸载demo数据" >
						<!--	<input type="button" onclick="window.location.href='demo.php?action=default'" value="恢复默认数据" >
						-->
					</div>
				
				</div>
				<div class="right_4"><p></p></div>				
				</div>
				<div class="clear"></div>
				</div>

<?php

	show_footer();
}	
/*--------------------first page end---------------------*/	


/*--------------------load page start-------------------------*/
	/*
		上一步验证通过后，提交之后，继续验证。
	*/
elseif($load=='load') {

	//check if /data/demolock.lock exist
	if(file_exists($demolockfile)) {
		show_msg('demo_locked', '', 0);
	}

	$dbhost = $CONFIG['dbhost'];		// 服务器地址
	$dbport = $CONFIG['dbport'];		// 服务器端口号
	$dbname = $CONFIG['dbname'];	// 数据库
	$dbuser = $CONFIG['dbuser'];		// 用户
	$dbpw = $CONFIG['dbpwd'];		// 密码
	$dbcharset = $CONFIG['dbcharset'];	// 字符集
	$pconnect = $CONFIG['pconnect'];	// 是否持续连接

		
	//新建数据库链接，准备写入数据。
	$db = new dbstuff;
	$db->connect	(
					$dbhost,
					$dbport, 
					$dbuser, 
					$dbpw, 
					$dbname, 
					DBCHARSET
				);

	if(!VIEW_OFF) {
		show_header();
		show_install();
	}
		

	//create table t_demo in DB.
	$create_demo_sql =str_replace("\r\n", "\n",file_get_contents($create_demo_table_sql_file));	
	runquery($create_demo_sql);	
	
	//load demo data
	// load .data in /install/data/demo/
	// load_demo_data();
	$sql = file_get_contents(ROOT_PATH.'./install/data/demo/install_demo_data.sql');
	// $sql.= file_get_contents(ROOT_PATH.'./install/data/default/install_default_data.sql');
	$sql = str_replace("\r\n", "\n", $sql);
	showjsmessage('正在安装演示数据 ...');
	runquery($sql);	
	showjsmessage('安装演示数据. .. 成功');
	//cope demo attachment to /data 
	if(file_copy($from_dir,$to_dir,1)){
		showjsmessage(lang('copy_attachment').' ... '.lang('succeed'));
	}
	
	//create demo lockfile /data/demo.lock		
	@touch($demolockfile);
?> 
	<script type="text/javascript">
		document.getElementById("showinfo").innerHTML="<input type=\"button\"  onclick=\"initinput()\" style=\"cursor: pointer;background:url(images/button_install_finished.gif);background-repeat:no-repeat;border-style:none; width:196px; height:29px;\" />";				
	</script>
<?php		
}

/*------------------load page end------------------------*/

/*------------------unload page start------------------------*/
elseif($load=='unload'){
	
	$dbhost = $CONFIG['dbhost'];		// 服务器地址
	$dbport = $CONFIG['dbport'];		// 服务器端口号
	$dbname = $CONFIG['dbname'];	// 数据库
	$dbuser = $CONFIG['dbuser'];		// 用户
	$dbpw = $CONFIG['dbpwd'];		// 密码
	$dbcharset = $CONFIG['dbcharset'];	// 字符集
	$pconnect = $CONFIG['pconnect'];	// 是否持续连接

		
	//新建数据库链接，准备写入数据。
	$db = new dbstuff;
	$db->connect	(
					$dbhost,
					$dbport, 
					$dbuser, 
					$dbpw, 
					$dbname, 
					DBCHARSET
				);

	if(!VIEW_OFF) {
		show_header();
		show_install();
	}
	
	//delete attachment file according to the info in db 
	//which use attachment in column
	showjsmessage('正在删除demo演示数据附件...');
	if(delete_attachment()){
		showjsmessage(lang('delete_attachment').' ... '.lang('succeed'));
	}
	
	//clean demo data in db
	if(clean_demo_data()){
		showjsmessage(lang('delete_demo_data').' ... '.lang('succeed'));
	}


	if($db->query('drop table '.$dbname.'.t_demo')){
		showjsmessage('删除t_demo表...'.lang('succeed'));
	}
	 
	//delete demo lockfile /data/demo.lock		
	@unlink($demolockfile);
?>
	<script type="text/javascript">
		addhtml="<input type=\"button\"  onclick=\"history.back()\" style=\"cursor: pointer;background:url(images/button_3.gif);background-repeat:no-repeat;border-style:none; width:139px; height:29px;\" />";				
		addhtml+="<input type=\"button\"  onclick=\"initinput()\" style=\"cursor: pointer;background:url(images/button_4.gif);background-repeat:no-repeat;border-style:none; width:196px; height:29px;\" />";
		document.getElementById("showinfo").innerHTML=addhtml;
	</script>	
<?php
}

/*------------------unload page end------------------------*/

?>