<?php

/**	
 *      (C)2009-2011 Orivon Inc.
 *      author@tiger
 */

if(!defined('Orivon')) {
	exit('Access Denied');
}

switch($option){
	case 'install_ots': 
		define('SOFT_NAME', 'oTraining');
		break;
	case 'update_ots': 
		define('SOFT_NAME', 'oTraining');
		break;
	case 'install_oes': 
		define('SOFT_NAME', 'oExam');
		break;
	case 'update_oes': 
		define('SOFT_NAME', 'oExam');
		break;
}

define('VERSION','1.4.2');
define('RELEASE','2010-10-21');
define('INSTALL_LANG', 'SC_UTF8');
define('CONFIG', './config.inc.php');
define('CHARSET', 'utf-8');
define('DBCHARSET', 'utf8');
$lockfile = ROOT_PATH.'./data/install.lock';
$timelock = ROOT_PATH.'./data/timelock.lock';
$demolockfile=ROOT_PATH.'./data/demolock.lock';
$table_demo='t_demo';
$create_demo_table_sql_file=ROOT_PATH.'./install/data/demo/table.demo.sql';
$from_dir=ROOT_PATH.'./install/data/demo/pictures/';
$to_dir=ROOT_PATH.'./data/pictures/';


define('METHOD_UNDEFINED', 255);
define('ENV_CHECK_RIGHT', 0);
define('ERROR_CONFIG_VARS', 1);
define('INSTALL_LOCKED', 2);
define('DATABASE_NONEXISTENCE', 3);
define('PHP_VERSION_TOO_LOW', 4);
define('MYSQL_VERSION_TOO_LOW', 5);
define('DBNAME_INVALID', 6);
define('DATABASE_ERRNO_2003', 7);
define('DATABASE_ERRNO_1044', 8);
define('DATABASE_ERRNO_1045', 9);
define('DATABASE_CONNECT_ERROR', 10);
define('TABLEPRE_INVALID', 11);
define('CONFIG_UNWRITEABLE',12);
define('ADMIN_USERNAME_INVALID',13);
define('ADMIN_EMAIL_INVALID', 14);
define('ADMIN_EXIST_PASSWORD_ERROR',15);
define('ADMININFO_INVALID', 16);
define('LOCKFILE_NO_EXISTS', 17);
define('TABLEPRE_EXISTS', 18);
define('ERROR_UNKNOW_TYPE', 19);
define('ENV_CHECK_ERROR', 20);
define('UNDEFINE_FUNC', 21);
define('MISSING_PARAMETER', 22);
define('LOCK_FILE_NOT_TOUCH', 23);
define('IONCUBE_CHECK_ERROR',24);
define('INSTALL_RUN_ERROR',25);

$func_items = array('mysql_connect', 'fsockopen', 'gethostbyname', 'file_get_contents', 'xml_parser_create');

$env_items = array
(
	'os' => array('c' => 'PHP_OS', 'r' => 'notset', 'b' => 'unix'),
	'php' => array('c' => 'PHP_VERSION', 'r' => '5.1', 'b' => '5.2'),
	'attachmentupload' => array('r' => 'notset', 'b' => '2M'),
	'diskspace' => array('r' => '10M', 'b' => 'notset'),
);
$ioncube_items = array
(
	'ioncube' => array('c'=>'','r'=>'','path'=>'','support'=>''),
);
$dirfile_items = array
(

	'config' => array('type' => 'file', 'path' => CONFIG),
	'data' => array('type' => 'dir', 'path' => './data'),
	'courseware' => array('type' => 'dir', 'path' => './data/courseware'),
	'download' => array('type' => 'dir', 'path' => './data/download'),
	'enclosure' => array('type' => 'dir', 'path' => './data/enclosure'),
	'error' => array('type' => 'dir', 'path' => './data/error'),
	'icons' => array('type' => 'dir', 'path' => './data/icons'),
	'media' => array('type' => 'dir', 'path' => './data/media'),
	'pictures' => array('type' => 'dir', 'path' => './data/pictures'),
	'scorm' => array('type' => 'dir', 'path' => './data/scorm'),
	'tpl' => array('type' => 'dir', 'path' => './data/tpl'),
	'upload' => array('type' => 'dir', 'path' => './data/upload'),
	'templates_c' => array('type' => 'dir', 'path' => './templates_c'),
	'templates_cache' => array('type' => 'dir', 'path' => './templates_cache'),	
);


$form_db_init_items = array
(
	'dbinfo' => array
	(
		'dbhost' => array('type' => 'text', 'required' => 1, 'reg' => '/^.+$/', 'value' => array('type' => 'var', 'var' => 'dbhost')),
		'dbport' => array('type' => 'text', 'required' => 1, 'reg' => '/^.+$/', 'value' => array('type' => 'var', 'var' => 'dbport')),		
		'dbname' => array('type' => 'text', 'required' => 1, 'reg' => '/^.+$/', 'value' => array('type' => 'var', 'var' => 'dbname')),
		'dbuser' => array('type' => 'text', 'required' => 0, 'reg' => '/^.*$/', 'value' => array('type' => 'var', 'var' => 'dbuser')),
		'dbpw' => array('type' => 'text', 'required' => 0, 'reg' => '/^.*$/', 'value' => array('type' => 'var', 'var' => 'dbpw')),
		'demodata' => array('type' => 'checkbox', 'required' => 0, 'reg' => '/^1$/', 'value' => array('type' => 'var', 'var' => '1')),
	),

);

$admininfo = array
(
	'admininfo' => array
	(
		'username' => array('type' => 'text', 'required' => 1, 'reg' => '/^.*$/', 'value' => array('type' => 'constant', 'var' => 'admin')),
		'password' => array('type' => 'password', 'required' => 1, 'reg' => '/^.*$/'),
		'password2' => array('type' => 'password', 'required' => 1, 'reg' => '/^.*$/'),

	)
);

if(preg_match("/install_[A-Za-z0-9]+$/", $option)){
	$form_db_init_items  = array_merge($form_db_init_items ,$admininfo);
}


?>
