<?php

/**  	
 * 		(C)2009-2011 Orivon Inc.
 *  	author @tiger
*/

error_reporting(0);
@set_time_limit(1000);
@set_magic_quotes_runtime(0);

define('Orivon', TRUE);
define('ROOT_PATH', dirname(__FILE__).'/../');

$option='install_oes';
// $option='update_oes';
// $option='install_ots';
// $option='update_ots';

require_once ROOT_PATH.'./install/include/install_var.php';
require_once ROOT_PATH.'./install/include/install_mysql.php';
require_once ROOT_PATH.'./install/include/install_function.php';
require_once ROOT_PATH.'./install/include/install_lang.php';

$view_off = getgpc('view_off');
define('VIEW_OFF', $view_off ? TRUE : FALSE);
$allow_method = array('show_license', 'env_check', 'db_init');
$step = intval(getgpc('step', 'R')) ? intval(getgpc('step', 'R')) : 0;
$method = getgpc('method');

if(file_exists(ROOT_PATH.CONFIG)) {
	include ROOT_PATH.CONFIG;
}else{
	show_msg('config_nonexistence', '', 0);
}
if(empty($method) || !in_array($method, $allow_method)) {
	$method = isset($allow_method[$step]) ? $allow_method[$step] : '';
}
if(empty($method)) {
	show_msg('method_undefined', $method, 0);
}
elseif(file_exists($lockfile) && $method != 'ext_info') {
	show_msg('install_locked', '', 0);
}
elseif(!class_exists('dbstuff')) {
	show_msg('database_nonexistence', '', 0);
}

if($method == 'show_license') {
	show_license();
} 
elseif($method == 'env_check') {
	VIEW_OFF && function_check($func_items);
	env_check($env_items);
	ioncube_check($ioncube_items);// php encoder check
	dirfile_check($dirfile_items);
	show_env_result($env_items,$ioncube_items, $dirfile_items, $func_items);
} 
elseif($method == 'db_init') {
	$submit = true;	
	$dbhost = $CONFIG['dbhost'];		// 服务器地址
	$dbport = $CONFIG['dbport'];		// 服务器端口号
	$dbname = $CONFIG['dbname'];	// 数据库
	$dbuser = $CONFIG['dbuser'];		// 用户
	$dbpw = $CONFIG['dbpwd'];		// 密码
	$dbcharset = $CONFIG['dbcharset'];	// 字符集
	$pconnect = $CONFIG['pconnect'];	// 是否持续连接
	$error_msg = array();
	if(isset($form_db_init_items) && is_array($form_db_init_items)) {
		foreach($form_db_init_items as $key => $items) {
			$$key = getgpc($key, 'p');
			if(!isset($$key) || !is_array($$key)) {
				$submit = false;
				break;
			}
			foreach($items as $k => $v) {
				$tmp = $$key;
				$$k = $tmp[$k];
				if(empty($$k) || !preg_match($v['reg'], $$k)) {
					if(empty($$k) && !$v['required']) {
						continue;
					}
					$submit = false;
					VIEW_OFF or $error_msg[$key][$k] = 1;
				}
			}
		}
	} else {
		$submit = false;
	}
	if($submit && !VIEW_OFF && $_SERVER['REQUEST_METHOD'] == 'POST') {

		if(preg_match("/install_[A-Za-z0-9]+$/", $option)){
			if($password != $password2) {
				$error_msg['admininfo']['password2'] = 1;
				$submit = false;
			}
			if($username) {
				if(strlen($username) > 15 || preg_match("/^$|^c:\\con\\con$|　|[,\"\s\t\<\>&]|^Guest/is", $username)) {
					show_msg('admin_username_invalid', $username, 0);
				}
			}else {
					show_msg('admininfo_invalid', '', 0);
			}
			
			$forceinstall = isset($_POST['dbinfo']['forceinstall']) ? $_POST['dbinfo']['forceinstall'] : '';		
			$dbname_exists = false;
			if(!empty($dbhost)) {			
				$dbname_exists = check_db($dbhost.':'.$dbport, $dbuser, $dbpw, $dbname, $tablepre);
				if($dbname_exists) {
					$form_db_init_items['dbinfo']['forceinstall'] = array('type' => 'checkbox', 'required' => 0, 'reg' => '/^.*+/','value' => array('type' => 'var', 'var' => '1'));
					$error_msg['dbinfo']['forceinstall'] = 1;
					if(file_exists($timelock)){
						unlink($timelock);
						$submit = true;
					}else{
						@touch($timelock);
						$submit = false;
					}					
					$dbname_exists = true;
				}
			}
		}
		if(preg_match("/update_[A-Za-z0-9]+$/", $option)){
			$dbname_exists = false;
			$dbname_exists=check_db($dbhost.':'.$dbport, $dbuser, $dbpw, $dbname, $tablepre);
			if(!$dbname_exists){
				show_msg('dbinfo_dbnamenotexist_invalid', '', 0);
			}
		}
		
		if($dbport<1 || $dbport>65535 || !preg_match("/^[1-9]\d*$/", $dbport)){
			$error_msg['dbinfo']['dbport'] = 1;
			$submit = false;
		} 

		if(!(preg_match("/\d+\.\d+\.\d+\.\d+/", $dbhost) || preg_match("/[A-Za-z0-9]+$/", $dbhost)) ){
			$error_msg['dbinfo']['dbhost'] = 1;
			$submit = false;
		}		
	}
	
	if($submit) {	
		$step = $step + 1;
		if(empty($dbname)) {
			show_msg('dbname_invalid', $dbname, 0);
		}else {		
		$link = @mysql_connect($dbhost.':'.$dbport, $dbuser, $dbpw);		
		if(mysql_get_server_info() > '4.1') {
			mysql_query("CREATE DATABASE IF NOT EXISTS `$dbname` DEFAULT CHARACTER SET ".DBCHARSET, $link);
		} else {
			mysql_query("CREATE DATABASE IF NOT EXISTS `$dbname`", $link);
		}
		if(mysql_errno()) {
			show_msg('database_errno_1044', mysql_error(), 0);
		}
		mysql_close($link);
		}
		$configfile = "../config.inc.php";
		$bf=file_get_contents($configfile);
		$s= preg_replace('/\$CONFIG\[\'dbhost\'\]="\S+";/', '$CONFIG[\'dbhost\']="'.$dbhost.'";',$bf);
		$s= preg_replace('/\$CONFIG\[\'dbport\'\]="\S+";/', '$CONFIG[\'dbport\']="'.$dbport.'";',$s);
		$s= preg_replace('/\$CONFIG\[\'dbname\'\]="\S+";/', '$CONFIG[\'dbname\']="'.$dbname.'";',$s);
		$s= preg_replace('/\$CONFIG\[\'dbuser\'\]="\S+";/', '$CONFIG[\'dbuser\']="'.$dbuser.'";',$s);
		$s= preg_replace('/\$CONFIG\[\'dbpwd\'\]="\S+";/', '$CONFIG[\'dbpwd\']="'.$dbpw.'";',$s);
		file_put_contents($configfile,$s);
		flush();
		ob_flush();
		
		$db = new dbstuff;
		$db->connect($dbhost,$dbport, $dbuser, $dbpw, $dbname, DBCHARSET);
		if(!VIEW_OFF) {
			show_header();
			show_install();
		}
		if(preg_match("/install_[A-Za-z0-9]+$/", $option)){
			$data_dir = 'data/'; 
			$res_dir = opendir($data_dir);
			while(false != ($file=readdir($res_dir))){
					if($file=='.' || $file=='..') continue;
					if(in_array('table', explode('.', $file))) {
						$table_sql .= file_get_contents($data_dir.$file)."\n";
					}
					if(in_array('proc', explode('.', $file))) {
						$procedure_sql .= file_get_contents($data_dir.$file)."\n";					
					}
			}
					
			$table_sql=str_replace("\r\n", "\n", $table_sql);
			$forceinstall = isset($_POST['dbinfo']['forceinstall']) ? $_POST['dbinfo']['forceinstall'] : '';
			if(!$dbname_exists ){
					runquery($table_sql);
					runprocedure($procedure_sql);				
					$sql = file_get_contents(ROOT_PATH.'./install/data/default/install_default_data.sql');
					$sql = str_replace("\r\n", "\n", $sql);
					runquery($sql);
					
					if($demodata) {
						$create_demo_sql =str_replace("\r\n", "\n",file_get_contents($create_demo_table_sql_file));	
						runquery($create_demo_sql);						
						$sql = file_get_contents(ROOT_PATH.'./install/data/demo/install_demo_data.sql');
						$sql = str_replace("\r\n", "\n", $sql);
						runquery($sql);	
						if(file_copy($from_dir,$to_dir,1)){
							showjsmessage(lang('copy_attachment').' ... '.lang('succeed'));
						}								
						@touch($demolockfile);
						}	
					
					
					$db->query("REPLACE INTO $dbname.t_admin (user_id,username, pwd,login_count,last_login_tm,last_login_ip) VALUES (1, '$username', password(\"$password\"),0,now(),'127.0.0.1') ");
					install_run_error('addadmin','t_admin');
					$db->query("REPLACE INTO $dbname.t_admin_group_user(user_id, group_id, group_pid, create_user_id, create_tm) values(1,1,0,1,now())");
					install_run_error('addadmin','t_admin_group_user');
					$db->query("REPLACE INTO $dbname.t_user(user_id, username, nickname, real_name, pwd, status) values(1,'$username','$username','$username',password(\"$password\"),'070102')");
					install_run_error('addadmin','t_user');	
			}
			elseif($dbname_exists && $forceinstall){
					runquery($table_sql);
					runprocedure($procedure_sql);
					$sql = file_get_contents(ROOT_PATH.'./install/data/default/install_default_data.sql');
					$sql = str_replace("\r\n", "\n", $sql);
					runquery($sql);
					
					if($demodata) {
						$create_demo_sql =str_replace("\r\n", "\n",file_get_contents($create_demo_table_sql_file));	
						runquery($create_demo_sql);						
						$sql = file_get_contents(ROOT_PATH.'./install/data/demo/install_demo_data.sql');
						$sql = str_replace("\r\n", "\n", $sql);
						runquery($sql);	
						if(file_copy($from_dir,$to_dir,1)){
							showjsmessage(lang('copy_attachment').' ... '.lang('succeed'));
						}								
						@touch($demolockfile);
						}	
							
					$db->query("REPLACE INTO $dbname.t_admin (user_id,username, pwd,login_count,last_login_tm,last_login_ip) VALUES (1, '$username', password(\"$password\"),0,now(),'127.0.0.1') ");
					install_run_error('addadmin','t_admin');
					$db->query("REPLACE INTO $dbname.t_admin_group_user(user_id, group_id, group_pid, create_user_id, create_tm) values(1,1,0,1,now())");
					install_run_error('addadmin','t_admin_group_user');
					$db->query("REPLACE INTO $dbname.t_user(user_id, username, nickname, real_name, pwd, status) values(1,'$username','$username','$username',password(\"$password\"),'070102')");
					install_run_error('addadmin','t_user');
			}
			else{
					 runprocedure($procedure_sql);
			}

			}		
		/*
			update升级包安装
		*/
		if(preg_match("/update_[A-Za-z0-9]+$/", $option)){
			//dosomething about update;
			
			$sql = "SHOW TABLES";
			$rs = mysql_query($sql);
			$arr_client_tables = array();
			while($row = mysql_fetch_row($rs)){
				$arr_client_tables[] = $row[0];
			}
			
			$update_data_dir = './data/update/';
			$f = opendir($update_data_dir);
			while(false != ($file = readdir($f))){
				if($file == '.' || $file == '..') continue;
				$table_name = pathinfo($file, PATHINFO_FILENAME);
				if(!in_array($table_name, $arr_client_tables)){
					$sql = file_get_contents($update_data_dir.$file);
					$sql = str_replace("\r\n", "\n", $sql);
					runquery($sql);
				}
			}
			closedir($f);
			
			$alter_table_sql_file = ROOT_PATH.'install/data/update.sql';
			$contents = file_get_contents($alter_table_sql_file);
			$arr_sql = explode(";", $contents);
			foreach($arr_sql as $sql){
				$sql = trim($sql);
				if(empty($sql)) continue;
				preg_match('/ALTER TABLE\s+`(\w+)`\s+/iu', $sql, $table_name);
				$table_name=is_array($table_name) ? array_pop($table_name) : '';
				$bool = mysql_query($sql);
				if($bool){
					 showjsmessage('更新表('.$table_name.')结构成功');
				}else{
					$errno = mysql_errno();
					switch($errno){
						case '1060':
							showjsmessage('表('.$table_name.')结构已更新到最新版本');
							break;
						default :
							showjsmessage('表('.$table_name.')结构已更新到最新版本');
							break;
					}
				}
			}
		}	
		@touch($lockfile);
		VIEW_OFF && show_msg('initdbresult_succ');
		if(!VIEW_OFF) {	
			echo '<script type="text/javascript">
					document.getElementById("showinfo").innerHTML="<input type=\"button\"  onclick=\"initinput()\" style=\"cursor: pointer;background:url(images/button_install_finished.gif);background-repeat:no-repeat;border-style:none; width:196px; height:29px;\" />";				
				</script>';
		}
		exit;
	}
	if(VIEW_OFF) {
		show_msg('missing_parameter', '', 0);
	} else {
		show_form($form_db_init_items, $error_msg);
	}
	
} 
