{{include file="$_root/templates/$_templates/admin/index/admin_header.tpl.php"}}
<link href="{{$_ROOT_URL}}/templates/{{$_templates}}/css/admin/test.css" rel="stylesheet" type="text/css" />
<link href="{{$_ROOT_URL}}/templates/{{$_templates}}/css/facebox.css" rel="stylesheet" type="text/css" />
</head>
<body class="body_content">
<div id='op_status' style='display:none'></div>
<div id="loading" style="display:none"></div>
<div id="pop_div" style="display:none"></div>
<div id='content' class="ana_content">
	<div id="papr_info" class="papr_analysis_info">
		<h2 style="font-size:16px">{{$_papr_name}}</h2>
		<div class="papr_a_sub_info">
			<h4>试卷信息</h4>
			<ul>
				<li><span>试卷分类：</span><label id="i_papr_category" style="color:#90A725"><strong>{{$_papr_category}}</strong></label></li>
				<li><span>试题数量：</span><label id="i_papr_qsn_count" style="color:#90A725"><strong>{{$_qsn_count}}</strong></label> </li>
				<li><span>难度系数对应的题目数量：</span><label id="i_papr_qsn_level" style="color:#90A725"><strong>{{$_papr_qsn_level}}</strong></label></li>
			</ul>
		</div>
	</div>
	<div class="papr_search_condition" id="p_condition">
		<h4>搜索项目</h4>
		<ul>
			<li>
				<span>试题标签：</span>
				<select id="type_label">
					<option value=''></option>
					{{section name=dt loop=$_qsn_label}}
					{{if $_qsn_label[dt].qsn_type ne ""}}
					<option value='{{$_qsn_label[dt].qsn_type}}'>
					{{/if}}
					{{if $_qsn_label[dt].qsn_type_label ne ""}}
						{{$_qsn_label[dt].qsn_type_label}}</option>
					{{/if}}
					{{/section}}
				</select>
			</li>
			<li>
				<span>试题难度范围：</span>
				<span id="qsn_level">
				{{section name=dt loop=$_qsn_level_range}}
					{{if $_qsn_level_range[dt].qsn_level ne ""}}
						<input type="radio" name="q_level" id="{{$_qsn_level_range[dt].qsn_level}}"/>
						<label for="{{$_qsn_level_range[dt].qsn_level}}" style="cursor:pointer">
					{{/if}}
					{{if $_qsn_level_range[dt].qsn_level_name ne ""}}
						{{$_qsn_level_range[dt].qsn_level_name}}
						</label>&nbsp;
					{{/if}}
				{{/section}}
				</span>
			</li>
			<li>
				<span>参加考试次数：</span>
				<select id="exam_times">
					{{section name=dt loop=$_exam_times}}
						<option value='{{$_exam_times[dt].exam_times}}'>{{$_exam_times[dt].exam_times}}</option>
					{{/section}}
				</select>
			</li>
		</ul>
		<ul>
			<li>
				<span><input type="checkbox" id="r_rank" checked onclick="sort_check('r_rank')" /><label for="r_rank" >按正确率排序：</label></span>
				<input type="radio" id="right_h_l" name="right_" /><label for="right_h_l" style="cursor:pointer">从高到低</label>&nbsp;<input type="radio" id="right_l_h" name="right_" /><label for="right_l_h" style="cursor:pointer">从低到高</label>
			</li>
		</ul>
		<ul>
			<li>
				<span><input type="checkbox" id="p_rank" onclick="sort_check('p_rank')"/><label for="p_rank">按部分正确率排序：</label></span>
				<input type="radio" id="pright_h_l" name="pright_" disabled /><label for="pright_h_l" style="cursor:pointer">从高到低</label>&nbsp;<input type="radio" id="pright_l_h" name="pright_" disabled /><label for="pright_l_h" style="cursor:pointer">从低到高</label>
			</li>			
		</ul>
		<ul>
			<li>
				<span><input type="checkbox" id="e_rank" onclick="sort_check('e_rank')"/><label for="e_rank">按错误率排序：</label></span>
				<input type="radio" id="error_h_l" name="error_" disabled /><label for="error_h_l" style="cursor:pointer">从高到低</label>&nbsp;<input type="radio" id="error_l_h" name="error_" disabled /><label for="error_l_h" style="cursor:pointer">从低到高</label>
			</li>
		</ul>
	</div>
	<div class="papr_ana_save_block">		
			<ul>
				<li>
					<input type="button" class="middle_btn" value="显示试题" onclick="show_papr_qsn_list()"/>
					<input type="button" class="btn" value="重置" onclick="reset_condition()"/>
					<input type="button" class="btn" value="关闭" onclick="window.close()"/>
					<input type="hidden" value="{{$_exam_id}}" id="exam_id"/>
					<input type="hidden" value="{{$_papr_id}}" id="papr_id"/>
					<input type="button" value="导出数据" class="long_btn" id="export_obj" onclick="export_paper_analysis_papr()"/>
				</li>
			</ul>		
	</div>
	<div id="papr_analysis_qsn_list">
			{{include file="paper_analysis_qsn_list.tpl.php"}}
	</div>
</div>
<script type="text/javascript" src="{{$_ROOT_URL}}/templates/{{$_templates}}/js/jquery.js"></script>
<script type="text/javascript" src="{{$_ROOT_URL}}/templates/{{$_templates}}/js/admin/admin.js" ></script>
<script type="text/javascript" src="{{$_ROOT_URL}}/templates/{{$_templates}}/js/admin/analysis_paper.js" ></script>
<script type="text/javascript" src="{{$_ROOT_URL}}/templates/{{$_templates}}/js/facebox.js" ></script>

{{include file="$_root/templates/$_templates/admin/index/admin_footer.tpl.php"}}
