DROP PROCEDURE IF EXISTS `pdo_pagination`;
CREATE PROCEDURE  `pdo_pagination`(in xsql text,in page_idx integer(10), in page_size integer(10),
out out_sql text)
begin 
  declare r_offset integer(11);  
  declare cou integer(11) default 0;
  declare r_cnt integer(11);
  set @r_offset=(page_idx-1) * page_size ;
    set @strsql=concat('select count(*) into @r_cnt from (',xsql,') t');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

    set out_sql=concat('select  t.*,',@r_cnt,' as row_count from (',xsql,') t limit ',@r_offset,',',page_size);
 
  
  
  
  
  
  
        
end



