DROP PROCEDURE IF EXISTS `users_add_exam_answer`;
CREATE PROCEDURE  `users_add_exam_answer`(IN par_answer TEXT)
begin
    set @strsql=concat('insert into t_user_exam_answer(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;






  
    
        
end

DROP PROCEDURE IF EXISTS `users_add_group`;
CREATE PROCEDURE  `users_add_group`(IN par_group_pid int(10), IN par_group_name VARCHAR(50), IN par_group_desc VARCHAR(255), IN par_create_user_id int(10))
begin
  if par_group_desc is null then
      set @strsql=concat('insert into t_group(group_pid,group_name,group_desc,create_tm,create_user_id) values(','''',par_group_pid,'''',',','''',par_group_name,'''',',null,','sysdate()',',','''',par_create_user_id,'''', ')');
  else
      set @strsql=concat('insert into t_group(group_pid,group_name,group_desc,create_tm,create_user_id) values(','''',par_group_pid,'''',',','''',par_group_name,'''',',','''',par_group_desc,'''',',','sysdate()',',','''',par_create_user_id,'''', ')');
  end if;

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_add_user`;
CREATE PROCEDURE  `users_add_user`(IN par_group_id int(10), IN par_real_name VARCHAR(20), IN par_username VARCHAR(20),
 IN par_password VARCHAR(50), IN par_email VARCHAR(50),IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),IN par_gender tinyint(1),IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30),
 IN par_reg_ip VARCHAR(15), IN par_study_point INT(4))
begin
 set @strsql='insert into t_user(study_point,real_name,username,pwd,email,idcard,examcard,gender,tel,mobiletel,reg_ip,reg_tm) values(';

  if par_study_point is null then
    set @strsql=concat(@strsql,0);
  else
    set @strsql=concat(@strsql,par_study_point);
  end if;

  if par_real_name is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_real_name,'''');
  end if;

  if par_username is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_username,'''');
  end if;

  if par_password is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','password(','''',par_password,'''',')');
  end if;

  if par_email is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_email,'''');
  end if;

  if par_idcard is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_idcard,'''');
  end if;

  if par_examcard is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_examcard,'''');
  end if;

  if par_gender is null then
    set @strsql=concat(@strsql,',1');
  else
    set @strsql=concat(@strsql,',',par_gender);
  end if;

  if par_tel is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_tel,'''');
  end if;

  if par_mobiletel is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_mobiletel,'''');
  end if;

  if par_reg_ip is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_reg_ip,'''');
  end if;

  set @strsql=concat(@strsql,',sysdate())');

  prepare stmt from @strsql;
  execute stmt;

  set @uid = last_insert_id();
  set @strsql=concat('insert t_user_group(user_id,group_id) values(','''',@uid,'''',',','''',par_group_id,'''',')');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  update t_exam set exam_user_count=exam_user_count+1 where exam_all_person=1;
  
    
end

DROP PROCEDURE IF EXISTS `users_add_user_other_app`;
CREATE PROCEDURE  `users_add_user_other_app`(IN par_user_id int(10), IN par_group_id int(10), IN par_real_name VARCHAR(20), IN par_username VARCHAR(20),
 IN par_password VARCHAR(50), IN par_email VARCHAR(50),IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),IN par_gender tinyint(1),IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30),
 IN par_reg_ip VARCHAR(15))
begin

  set @uid=par_user_id;

  select trim(s.setting_value) setting_value into @spoint
  from t_setting s left join t_common_cde c on c.c_cde=s.setting_value where
  s.setting_name='point_create_user' and s.category_pname='ask' and s.category_name='point' and s.user_id=0;

  set @strsql='insert into t_user(user_id,study_point,real_name,username,pwd,email,idcard,examcard,gender,tel,mobiletel,reg_ip,reg_tm) values(';
  set @strsql=concat(@strsql,'''',@uid,'''',',');

  set @strsql=concat(@strsql,@spoint);


  if par_real_name is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_real_name,'''');
  end if;

  if par_username is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_username,'''');
  end if;

  if par_password is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','password(','''',par_password,'''',')');
  end if;

  if par_email is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_email,'''');
  end if;

  if par_idcard is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_idcard,'''');
  end if;

  if par_examcard is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_examcard,'''');
  end if;

  if par_gender is null then
    set @strsql=concat(@strsql,',1');
  else
    set @strsql=concat(@strsql,',',par_gender);
  end if;

  if par_tel is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_tel,'''');
  end if;

  if par_mobiletel is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_mobiletel,'''');
  end if;

  if par_reg_ip is null then
    set @strsql=concat(@strsql,',null');
  else
    set @strsql=concat(@strsql,',','''',par_reg_ip,'''');
  end if;

  set @strsql=concat(@strsql,',sysdate())');

  prepare stmt from @strsql;
 execute stmt;

    set @strsql=concat('insert t_user_group(user_id,group_id) values(','''',@uid,'''',',','''',par_group_id,'''',')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  update t_exam set exam_user_count=exam_user_count+1 where exam_all_person=1;







  
        
end

DROP PROCEDURE IF EXISTS `users_delete_exam_info`;
CREATE PROCEDURE  `users_delete_exam_info`(IN par_exam_id CHAR(32), IN par_user_id INTEGER(10),
IN par_papr_id CHAR(32), IN par_exam_times SMALLINT(6))
begin

    set @strsql=concat('delete from t_user_exam where exam_id = "',par_exam_id,'" AND
      user_id = "',par_user_id,'" AND papr_id = "',par_papr_id,'" AND exam_times = ',par_exam_times);
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exam_answer where exam_id = "',par_exam_id,'" AND
      user_id = "',par_user_id,'" AND papr_id = "',par_papr_id,'" AND exam_times = ',par_exam_times);
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exam_info where exam_id = "',par_exam_id,'" AND
      user_id = "',par_user_id,'" AND papr_id = "',par_papr_id,'" AND exam_times = ',par_exam_times);
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_delete_group`;
CREATE PROCEDURE  `users_delete_group`(IN par_group_id int(10))
begin
    set @strsql=concat('delete from t_group where group_id=','''',par_group_id,'''');
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_delete_group_other_app`;
CREATE PROCEDURE  `users_delete_group_other_app`(IN par_group_id text)
begin
    set @strsql=concat('delete from t_group where group_id in (',par_group_id,')');
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;







  
        
end

DROP PROCEDURE IF EXISTS `users_delete_user`;
CREATE PROCEDURE  `users_delete_user`(IN par_user_id text)
begin
    set @strsql=concat('delete from t_user  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_group  where user_id in(',par_user_id,')');

    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_exam_exclude_user where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_role_user  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exam  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exam_answer  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exam_info  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exercise  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exercise_answer  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_user_exercise_info  where user_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_message  where sender_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    set @strsql=concat('delete from t_message  where recipients_id in(',par_user_id,')');
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_export_search_user`;
CREATE PROCEDURE  `users_export_search_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),IN par_status VARCHAR(10),IN par_username VARCHAR(20),IN par_email VARCHAR(50),
IN par_gender TINYINT,IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),
IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30),IN par_reg_begin_tm DATE,IN par_reg_end_tm DATE
)
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

  insert into tmp_group_tree(id,pid,level,position)
  values (par_group_id,par_group_pid,v_level,v_position);
  set v_row_count := row_count();

  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_tree(id,pid,level,position)
    select g.group_id,g.group_pid,v_level + 1,@position := @position+1
    from t_group g inner join tmp_group_tree t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;

    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;

  set @strsql=' select u.user_id,u.user_id2,u.username,u.nickname,u.real_name,u.email,c.desc_cn status,u.icon,u.introduction,u.gender,u.birthday,
                u.idcard,u.examcard,u.tel,u.mobiletel,u.position,u.reg_ip,u.reg_tm,u.update_tm,u.login_count,
                u.last_login_tm,u.last_login_ip,u.study_point,u.study_day_answer_point,g.group_id,g.group_name from t_user u
                join t_common_cde c on c.c_cde=u.status';

  if par_group_id !=1 then
      set @strsql=concat(@strsql,' join t_user_group r on r.user_id=u.user_id
              join t_group g on g.group_id=r.group_id
              join tmp_group_user_tree t on t.id=r.group_id where u.user_id!=1 ');
  else
      set @strsql=concat(@strsql,' left join t_user_group r on r.user_id=u.user_id left join t_group g on g.group_id=r.group_id
              left join tmp_group_user_tree t on t.id=r.group_id where u.user_id!=1 ');
  end if;


  if par_real_name is not null then
            set @strsql=concat(@strsql,' and u.real_name like ','''',par_real_name,'%''');
  end if;

  if par_status is not null && par_status!='' then
     set @strsql=concat(@strsql,' and u.status = ','''',par_status,'''');
  end if;

  if par_username is not null then
     set @strsql=concat(@strsql,' and u.username like ','''',par_username,'%''');
  end if;

  if par_email is not null then
     set @strsql=concat(@strsql,' and u.email like ','''',par_email,'%''');
  end if;

  if par_gender is not null then
     set @strsql=concat(@strsql,' and u.gender = ',par_gender);
  end if;

  if par_idcard is not null then
     set @strsql=concat(@strsql,' and u.idcard like ','''',par_idcard,'%''');
  end if;

  if par_examcard is not null then
     set @strsql=concat(@strsql,' and u.examcard like ','''',par_examcard,'%''');
  end if;

  if par_tel is not null then
     set @strsql=concat(@strsql,' and u.tel like ','''',par_tel,'%''');
  end if;

  if par_mobiletel is not null then
     set @strsql=concat(@strsql,' and u.mobiletel like ','''',par_mobiletel,'%''');
  end if;

  if par_reg_begin_tm is not null && par_reg_end_tm is not null then
     set @strsql=concat(@strsql,' and u.reg_tm between ','''',par_reg_begin_tm,'''',' and ','''',par_reg_end_tm,'''');
  end if;

  set @strsql=concat(@strsql,' order by u.user_id');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  truncate table tmp_group_tree;

      
end

DROP PROCEDURE IF EXISTS `users_export_select_user`;
CREATE PROCEDURE  `users_export_select_user`(IN par_user_id text)
begin

   set @strsql='select t.*,g.group_id,r.group_name
               from t_user t join t_user_group g on g.user_id=t.user_id
               join t_group r on r.group_id=g.group_id ';

    if par_user_id is not null then
    set @strsql=concat(@strsql,' and t.user_id in (',par_user_id,')');
    end if;

   set @strsql=concat(@strsql,' order by t.user_id');

   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_import_user`;
CREATE PROCEDURE  `users_import_user`(IN par_imp_type int(10),IN par_user_id int(10),IN par_username varchar(20),
IN par_email varchar(50),IN par_idcard varchar(30),IN par_examcard varchar(30),IN par_userdata text,IN par_groupdata text,OUT par_row_count int(10))
begin

    if par_user_id is not null then
      set @udt=concat('(',par_user_id,',',par_userdata,')');

      if par_imp_type =1 then
        set @strsql=concat('insert ignore into t_user(user_id, user_id2, username, nickname, real_name, pwd, email, status, icon,
                                    introduction, gender, birthday, idcard,examcard, tel, mobiletel, position, reg_ip, reg_tm, update_tm,
                                    login_count, last_login_tm, last_login_ip, study_point, study_day_answer_point) values',@udt);
      else
        set @strsql=concat('replace into t_user(user_id, user_id2, username, nickname, real_name, pwd, email, status, icon,
                                    introduction, gender, birthday, idcard,examcard, tel, mobiletel, position, reg_ip, reg_tm, update_tm,
                                    login_count, last_login_tm, last_login_ip, study_point, study_day_answer_point) values',@udt);
      end if;

      prepare stmt from @strsql;
      execute stmt;

      set @udata=concat('(',par_user_id,',',par_groupdata,')');

      if par_imp_type =1 then
        set @strsql=concat('insert ignore into t_user_group(user_id,group_id) values',@udata);
      else
        set @strsql=concat('replace into t_user_group(user_id,group_id) values',@udata);
      end if;

      prepare stmt from @strsql;
      execute stmt;
    else
       set @uid=null;
      if par_username is not null then
          select user_id into @uid from t_user where username=par_username;
      elseif par_email is not null then
          select user_id into @uid from t_user where email=par_email;
      elseif par_idcard is not null then
          select user_id into @uid from t_user where idcard=par_idcard;
      elseif par_examcard is not null then
          select user_id into @uid from t_user where examcard=par_examcard;
      end if;

      if @uid is null then
        select user_id into @uid from t_user order by user_id desc limit 1;
        set @uid=@uid+1;
      end if;

      set @dt=concat('(',@uid,',',par_userdata,')');

      if par_imp_type =1 then
          set @strsql=concat('insert ignore into t_user(user_id,user_id2, username, nickname, real_name, pwd, email, status, icon,
                                    introduction, gender, birthday, idcard,examcard, tel, mobiletel, position, reg_ip, reg_tm, update_tm,
                                    login_count, last_login_tm, last_login_ip, study_point, study_day_answer_point) values',@dt);
      else
          set @strsql=concat('replace into t_user(user_id,user_id2, username, nickname, real_name, pwd, email, status, icon,
                                    introduction, gender, birthday, idcard,examcard, tel, mobiletel, position, reg_ip, reg_tm, update_tm,
                                    login_count, last_login_tm, last_login_ip, study_point, study_day_answer_point) values',@dt);
      end if;

      prepare stmt from @strsql;
      execute stmt;

      set @udata=concat('(',@uid,',',par_groupdata,')');

      if par_imp_type =1 then
        set @strsql=concat('insert ignore into t_user_group(user_id,group_id) values',@udata);
      else
        set @strsql=concat('replace into t_user_group(user_id,group_id) values',@udata);
      end if;

      prepare stmt from @strsql;
      execute stmt;
    end if;

    select row_count() into par_row_count;
    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_make_examcard_pwd`;
CREATE PROCEDURE  `users_make_examcard_pwd`(IN par_user_id int(10),IN par_examcard varchar(30),IN par_pwd varchar(50))
begin

if par_user_id is not null then
        set @strsql='update t_user set ';

        if par_examcard is not null then
            set @strsql=concat(@strsql,' examcard=',par_examcard,',');
        end if;

        if par_pwd is not null then
            set @strsql=concat(@strsql,' pwd=password(','''',par_pwd,'''','),');
        end if;
        set @strsql=substring(@strsql,1,length(@strsql)-1);
        set @strsql=concat(@strsql,' where user_id=','''',par_user_id,'''');

        prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
end if;




  
        
end

DROP PROCEDURE IF EXISTS `users_move_group`;
CREATE PROCEDURE  `users_move_group`(IN par_group_id int(10),IN par_group_pid int(10),
IN par_update_user_id int(10))
begin
    set @strsql=concat('update t_group set group_pid=','''',par_group_pid,'''',',','update_user_id=',par_update_user_id, ',
    update_tm=sysdate() where group_id=','''',par_group_id,'''');
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_select_admin_group`;
CREATE PROCEDURE  `users_select_admin_group`(IN par_username varchar(50))
begin

  set @strsql=concat('select gu.group_id,gu.group_pid from t_admin_group_user gu
            join t_user u on u.user_id=gu.user_id and u.username= ','''',par_username,'''');
  prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_select_export_user`;
CREATE PROCEDURE  `users_select_export_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),
IN par_search_flg TINYINT,IN par_user_id text)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

 if par_group_id is not null then
      insert into tmp_group_tree(id,pid, level,position)
      values (par_group_id,par_group_pid,v_level,v_position);
      set v_row_count := row_count();

      while v_row_count != 0 do
        set @position := 0;
        insert into tmp_group_tree(id,pid,level,position)
        select g.group_id,g.group_pid,v_level + 1,@position := @position+1
        from t_group g inner join tmp_group_tree t on g.group_pid = t.id
        where t.level = v_level and g.group_id !='0' order by g.group_id;

        set v_row_count := row_count();
        set v_level := v_level + 1;
      end while;
  end if;

  set @strsql='select t.user_id,g.group_id,r.group_name,t.real_name,t.username,t.email
               from t_user t left join t_user_group g on g.user_id=t.user_id
               left join t_group r on r.group_id=g.group_id ';

   if par_group_id is not null then
      if par_search_flg =3 then
          set @strsql=concat(@strsql,' left join tmp_group_tree m on m.pid=r.group_pid and m.id=r.group_id');
      end if;
   end if;

   if par_search_flg =2 then
            set @strsql=concat(@strsql,' and t.user_id in(select user_id
                                            from t_user_group ug where group_id in(select group_id from t_user_group
                                            where user_id in(',par_user_id,')))');
   else
      if par_user_id is not null then
        set @strsql=concat(@strsql,' and t.user_id in (',par_user_id,')');
      end if;
   end if;

   if par_real_name is not null then
        set @strsql=concat(@strsql,' and t.real_name like ','''',par_real_name,'%''');
   end if;

   set @strsql=concat(@strsql,' order by t.real_name');

   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;

   if par_group_id is not null then
        truncate table tmp_group_tree;
   end if;






  
        
end

DROP PROCEDURE IF EXISTS `users_select_group_id`;
CREATE PROCEDURE  `users_select_group_id`(IN par_group_pid int(10))
begin
    set @strsql=concat('select group_id from t_group ',' where group_pid=','''',par_group_pid,'''',' order by CAST(group_id AS UNSIGNED) desc limit 1');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_select_roles`;
CREATE PROCEDURE  `users_select_roles`(in par_username varchar(20))
BEGIN
   select r.role_id,r.role_value from t_role r
   join t_role_user u on u.role_id=r.role_id
   join t_admin ur on ur.user_id=u.user_id where ur.username=par_username ;






  
        
end

DROP PROCEDURE IF EXISTS `users_select_series_user`;
CREATE PROCEDURE  `users_select_series_user`(IN par_user_id text)
begin

  set @strsql=' select u.user_id,u.user_id2,u.real_name,g.group_name,u.username,u.email,u.gender,
              u.idcard,u.examcard,u.tel,u.mobiletel,u.reg_tm,u.status,u.position
              from t_user u join t_user_group r on r.user_id=u.user_id
                        join t_group g on g.group_id=r.group_id where u.user_id in ';

  set @strsql=concat(@strsql,'(',par_user_id,')',' order by u.user_id');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;





  
        
end

DROP PROCEDURE IF EXISTS `users_select_single_user_info`;
CREATE PROCEDURE  `users_select_single_user_info`(IN par_user_id int(10))
begin
   set @strsql=concat('select t.user_id,t.real_name,t.username,t.email,t.study_point,t.idcard,t.examcard,t.gender,t.tel,t.mobiletel,t.status from t_user t where t.user_id =','''',par_user_id,'''');

   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;





  
        
end

DROP PROCEDURE IF EXISTS `users_select_user`;
CREATE PROCEDURE  `users_select_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10),IN par_status VARCHAR(10),
IN par_username VARCHAR(20),IN par_email VARCHAR(50),
IN par_gender TINYINT,IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),
IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30),IN par_reg_begin_tm DATE,IN par_reg_end_tm DATE)
begin
   declare v_level int unsigned default 0;
   declare v_position int unsigned default 1;
   declare v_row_count int unsigned default 0;

   insert into tmp_group_user_tree(id,pid, level,position)
   values (par_group_id,par_group_pid,v_level,v_position);

   set v_row_count := row_count();
   while v_row_count != 0 do
        set @position := 0;
        insert into tmp_group_user_tree(id,pid,level,position)
        select g.group_id,g.group_pid
        , v_level + 1
        , @position := @position+1
        from t_group g
        inner join tmp_group_user_tree t    on g.group_pid = t.id   where t.level = v_level and g.group_id !='0' order by g.group_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
   end while;

  set @strsql=' select u.user_id,u.real_name,g.group_name,u.username,u.email,u.gender,u.idcard,u.examcard,u.tel,u.mobiletel,reg_tm,status
              from t_user u';

  if par_group_id !=1 then
      set @strsql=concat(@strsql,' join t_user_group r on r.user_id=u.user_id
              join t_group g on g.group_id=r.group_id
              join tmp_group_user_tree t on t.id=r.group_id where u.user_id!=1 ');
  else
      set @strsql=concat(@strsql,' left join t_user_group r on r.user_id=u.user_id left join t_group g on g.group_id=r.group_id
              left join tmp_group_user_tree t on t.id=r.group_id where u.user_id!=1 ');
  end if;

  if par_real_name is not null then
     set @strsql=concat(@strsql,' and u.real_name like ','''',par_real_name,'%''');
  end if;

  if par_status is not null && par_status!='' then
     set @strsql=concat(@strsql,' and u.status = ','''',par_status,'''');
  end if;

  if par_username is not null then
     set @strsql=concat(@strsql,' and u.username like ','''',par_username,'%''');
  end if;

  if par_email is not null then
     set @strsql=concat(@strsql,' and u.email like ','''',par_email,'%''');
  end if;

  if par_gender is not null then
     set @strsql=concat(@strsql,' and u.gender = ',par_gender);
  end if;

  if par_idcard is not null then
     set @strsql=concat(@strsql,' and u.idcard like ','''',par_idcard,'%''');
  end if;

  if par_examcard is not null then
     set @strsql=concat(@strsql,' and u.examcard like ','''',par_examcard,'%''');
  end if;

  if par_tel is not null then
     set @strsql=concat(@strsql,' and u.tel like ','''',par_tel,'%''');
  end if;

  if par_mobiletel is not null then
     set @strsql=concat(@strsql,' and u.mobiletel like ','''',par_mobiletel,'%''');
  end if;

  if par_reg_begin_tm is not null && par_reg_end_tm is not null then
     set @strsql=concat(@strsql,' and u.reg_tm between ','''',par_reg_begin_tm,'''',' and ','''',par_reg_end_tm,'''');
  end if;

  set @strsql=concat(@strsql,' order by u.user_id');

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;

  truncate table tmp_group_user_tree;

      
end

DROP PROCEDURE IF EXISTS `users_update_group`;
CREATE PROCEDURE  `users_update_group`(IN par_group_id int(10), IN par_group_name VARCHAR(50), IN par_group_desc VARCHAR(255), IN par_update_user_id int(10))
begin
if par_group_desc is null then
  set @strsql=concat('update t_group set group_name=','''',par_group_name,'''',',',
    'group_desc=null,',
    'update_user_id=',par_update_user_id,',',
    'update_tm=sysdate()',
    ' where group_id=','''',par_group_id,'''');
else
    set @strsql=concat('update t_group set group_name=','''',par_group_name,'''',',',
        'group_desc=','''',par_group_desc,'''',',',
        'update_user_id=',par_update_user_id,',',
        'update_tm=sysdate()',
        ' where group_id=','''',par_group_id,'''');
end if;
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_update_user`;
CREATE PROCEDURE  `users_update_user`(IN par_user_id int(10), IN par_real_name VARCHAR(50),
IN par_username VARCHAR(20), IN par_email VARCHAR(50), IN par_password VARCHAR(50),IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),
IN par_gender VARCHAR(30),IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30))
begin
set @strsql=concat('update t_user set real_name=','''',par_real_name,'''');

  if par_email is not null then
    set @strsql=concat(@strsql,',email=','''',par_email,'''');
  else
    set @strsql=concat(@strsql,',email=''''');
  end if;

  if par_password is not null then
     set @strsql=concat(@strsql,',pwd=password(','''',par_password,'''',')');
  end if;

  if par_username is not null then
     set @strsql=concat(@strsql,',username=','''',par_username,'''');
  end if;

  if par_idcard is not null then
     set @strsql=concat(@strsql,',idcard=','''',par_idcard,'''');
  end if;

  if par_examcard is not null then
     set @strsql=concat(@strsql,',examcard=','''',par_examcard,'''');
  end if;

  if par_gender is not null then
     set @strsql=concat(@strsql,',gender=',par_gender);
  end if;

  if par_tel is not null then
    set @strsql=concat(@strsql,',tel=','''',par_tel,'''');
  end if;

  if par_mobiletel is not null then
    set @strsql=concat(@strsql,',mobiletel=','''',par_mobiletel,'''');
  end if;

  set @strsql=concat(@strsql,' where user_id =','''',par_user_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;






  
    
        
end

DROP PROCEDURE IF EXISTS `users_update_user_dep`;
CREATE PROCEDURE  `users_update_user_dep`(IN par_group_id INT(10), IN par_user_Id text)
begin
  set @strsql=concat('delete from t_user_group where user_id in (',par_user_id,')');

  prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @strsql=concat('insert into t_user_group(user_id,group_id) select user_id,',par_group_id,' from t_user where user_id in (',par_user_id,')');

  prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;






  
        
end

DROP PROCEDURE IF EXISTS `users_verify_user`;
CREATE PROCEDURE  `users_verify_user`(IN `par_user_id` text, IN `par_user_flg` int(2))
begin
    if par_user_flg is not null then
        if par_user_flg=1 then
            set @strsql=concat('update t_user set status=\'070102\' where user_id in(',par_user_id,')');
        end if;
        if par_user_flg=2 then
            set @strsql=concat('update t_user set status=\'070101\' where user_id in(',par_user_id,')');
        end if;
    end if;

    prepare stmt from @strsql;	
    execute stmt;
    deallocate prepare stmt;
  
      
end



