DROP TABLE IF EXISTS `t_session`;
CREATE TABLE `t_session` (
  `sid` char(12) NOT NULL,
  `ip` char(15) NOT NULL,
  `user_id` int(10) DEFAULT NULL,
  `username` char(20) DEFAULT NULL,
  `last_activity` int(10) unsigned NOT NULL DEFAULT '0',
  `exam_id` char(32) DEFAULT NULL,
  `exam_time` int(10) unsigned DEFAULT NULL,
  `exam_cmd` tinyint(1) unsigned DEFAULT NULL,
  `exam_start_tm` int(10) unsigned DEFAULT '0',
  `exercise_id` char(32) DEFAULT '0',
  `exercise_time` int(10) unsigned DEFAULT '0',
  `exercise_cmd` int(10) unsigned DEFAULT '0',
  `exercise_start_tm` int(10) unsigned DEFAULT '0',
  `homework_id` char(32) DEFAULT '0',
  `homework_time` int(10) unsigned DEFAULT '0',
  `homework_cmd` int(10) unsigned DEFAULT '0',
  `homework_start_tm` int(10) unsigned DEFAULT '0',
  `role_value` varchar(4000) DEFAULT NULL,
  `role_group` varchar(4000) DEFAULT NULL,
  `security_code` char(4) DEFAULT NULL,
  `c_id` bigint(20) unsigned DEFAULT '0',
  `w_id` bigint(20) unsigned DEFAULT '0',
  `play_time` int(10) unsigned DEFAULT '0',
  UNIQUE KEY `sid` (`sid`),
  KEY `session_user_id` (`user_id`) USING HASH
) ENGINE=MEMORY DEFAULT CHARSET=utf8;



