DROP TABLE IF EXISTS `tmp_qsn_atta_tree`;
CREATE TABLE `tmp_qsn_atta_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_qsn_att_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_qsn_delete_att_tree`;
CREATE TABLE `tmp_qsn_delete_att_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_qsn_del_att_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_qsn_delete_compounding_tree`;
CREATE TABLE `tmp_qsn_delete_compounding_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_q_d_c_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_qsn_delete_tree`;
CREATE TABLE `tmp_qsn_delete_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_qsn_d_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_qsn_display_content_tree`;
CREATE TABLE `tmp_qsn_display_content_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_qsn_group_tree`;
CREATE TABLE `tmp_qsn_group_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_g_g_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;



