DROP TABLE IF EXISTS `t_user_exam_answer_storage`;
CREATE TABLE  `t_user_exam_answer_storage` (
  `user_id` int(10) NOT NULL,
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`exam_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`exam_times`),
  KEY `index_usr_exam_a_s_qtype` (`qsn_type`) USING BTREE,
  KEY `index_usr_exam_a_s_pos` (`qsn_type_position`) USING BTREE,
  KEY `index_usr_exam_a_s` (`exam_id`,`papr_id`,`exam_times`,`user_id`) USING BTREE,
  KEY `index_usr_exam_a_s_u` (`user_id`) USING BTREE,
  KEY `index_usr_exam_a_s_qid` (`qsn_id`,`qsn_sub_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;