DROP TABLE IF EXISTS `t_user_exercise`;
CREATE TABLE  `t_user_exercise` (
  `exercise_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exercise_times` smallint(6) NOT NULL,
  `exercise_tm` datetime NOT NULL,
  `user_exercise_scoring` float NOT NULL,
  `exercise_point` float DEFAULT NULL,
  `exercise_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`exercise_id`,`user_id`,`exercise_times`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;