DROP TABLE IF EXISTS `t_user_exercise_answer`;
CREATE TABLE  `t_user_exercise_answer` (
  `user_id` int(10) NOT NULL,
  `exercise_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exercise_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`exercise_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`exercise_times`),
  KEY `Index_usr_exercise_a_qtype` (`qsn_type`) USING BTREE,
  KEY `Index_usr_exercise_a_pos` (`qsn_type_position`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;