DROP PROCEDURE IF EXISTS `cmn_add_category`;
CREATE PROCEDURE  `cmn_add_category`(IN par_c_cde vaRCHAR(20), IN par_p_cde vARCHAR(20), IN par_desc VARCHAR(255), IN par_create_user_id int(10))
begin    
    set @strsql=concat('insert into t_common_cde(c_cde,p_cde,p_flg,desc_cn,create_tm,create_user_id) values(','''',par_c_cde,'''',',','''',par_p_cde,'''',',','0',',','''',par_desc,'''',',','sysdate()',',','''',par_create_user_id,'''', ')');
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_cde_check`;
CREATE PROCEDURE  `cmn_cde_check`(IN par_p_cde varCHAR ( 20 ),IN par_c_cde VARCHAR(20))
begin
  set @strsql=concat('select desc_cn name from t_common_cde ',' where p_cde=','''',par_p_cde,'''',' and c_cde=','''',par_c_cde,'''',' limit 1');
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_delete`;
CREATE PROCEDURE  `cmn_delete`(IN par_cde TEXT)
begin
          set @strsql=concat('delete from t_common_cde where  c_cde in (',par_cde,')');
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_delete_category`;
CREATE PROCEDURE  `cmn_delete_category`(IN par_c_cde VARCHAR(20))
begin

  declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  set @mysql2='';

    insert into tmp_common_cde(id,pid, level,position)
    select c_cde,p_cde,v_level,v_position from t_common_cde
    where c_cde=par_c_cde;

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_common_cde(id,pid,level,position)
        select c.c_cde,c.p_cde
        , v_level + 1
        , @position := @position+1
        from t_common_cde c
        inner join tmp_common_cde t on c.p_cde= t.id
        where t.level = v_level
        order by c.c_cde;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

  delete from t_common_cde where c_cde in (select id from tmp_common_cde);
  truncate table tmp_common_cde;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_delete_list`;
CREATE PROCEDURE  `cmn_delete_list`(IN par_cde varchar(20),IN par_p_cde varchar(20))
begin
    set @strsql='';
    if par_p_cde is not null and par_cde is null then
          set @strsql=concat(@strsql,'delete from t_common_cde where p_cde=','''',par_p_cde,'''');

          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;

          set @strsql='';
          set @strsql=concat(@strsql,'delete from t_common_cde where  c_cde =','''',par_p_cde,'''');

          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
    else
          set @strsql=concat(@strsql,'delete from t_common_cde where  c_cde =','''',par_cde,'''');

          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;

          set @strsql='';
          set @strsql=concat(@strsql,'delete from t_common_cde where  p_cde =','''',par_cde,'''');
         
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
    end if;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_group_select`;
CREATE PROCEDURE  `cmn_group_select`(IN par_cde VARCHAR(2000))
begin
  set @strsql=concat('select t.c_cde group_cde,t.desc_cn group_name,d.c_cde cde,d.desc_cn name
from (select c.c_cde,c.desc_cn from t_common_cde c where c.p_cde in ',par_cde,') t
left join t_common_cde d on d.p_cde=t.c_cde');

    prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_insert`;
CREATE PROCEDURE  `cmn_insert`(IN par_cde VARCHAR(20),IN par_p_cde VARCHAR(20),IN par_p_flg int(1), IN par_desc VARCHAR(255), IN par_create_user_id int(10))
begin
          set @strsql=concat('insert into  t_common_cde(c_cde,p_cde,p_flg,desc_cn,create_tm,create_user_id) values(','''',par_cde,'''',',','''',par_p_cde,'''',',','''',par_p_flg,'''',',','''',par_desc,'''',',sysdate(),',par_create_user_id,')');
         
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_move_category`;
CREATE PROCEDURE  `cmn_move_category`(IN par_c_cde varchar(20),in par_p_cde varchar(20),
IN par_update_user_id int(10))
begin    
    set @strsql=concat('update t_common_cde set p_cde=','''',par_p_cde,'''',',','update_user_id=',par_update_user_id, ',update_tm=sysdate() where c_cde=','''',par_c_cde,'''');    
    prepare stmt from @strsql;  
    execute stmt;
    
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_move_group`;
CREATE PROCEDURE  `cmn_move_group`(IN par_c_cde varchar(20),in par_p_cde varchar(20),
IN par_update_user_id int(10))
begin    
    set @strsql=concat('update t_common_cde set p_cde=','''',par_p_cde,'''',',','update_user_id=',par_update_user_id, ',
    update_tm=sysdate() where c_cde=','''',par_c_cde,'''');    
    prepare stmt from @strsql;  
    execute stmt;
    
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select`;
CREATE PROCEDURE  `cmn_select`( IN par_cde varCHAR ( 20 ))
BEGIN
    set @strSQL=concat('select t.p_cde,t.c_cde cde,t.desc_cn name,p.desc_cn p_name from
                              t_common_cde t,t_common_cde p where t.p_cde=p.c_cde and t.p_cde like ''',par_cde,'%''');
    prepare stmt from @strSQL;
    execute stmt;
    DEALLOCATE PREPARE stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_category`;
CREATE PROCEDURE  `cmn_select_category`()
BEGIN
          set @strSQL=concat('select p_cde,c_cde cde,desc_cn name from t_common_cde t where t.p_flg =1');
          prepare stmt from @strSQL;
          execute stmt;
          DEALLOCATE PREPARE stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_category_id`;
CREATE PROCEDURE  `cmn_select_category_id`(IN par_p_cde VARCHAR(20))
begin       
  set @strsql=concat('select c_cde from t_common_cde ',' where p_cde=','''',par_p_cde,'''',' order by c_cde*1 desc limit 1');
  prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_category_name`;
CREATE PROCEDURE  `cmn_select_category_name`(IN par_c_cde VARCHAR(20))
BEGIN
  
  set @strsql=concat('select p_cde,c_cde,desc_cn from t_common_cde ',' where c_cde=','''',par_c_cde,'''',' order by c_cde*1 desc limit 1');
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_class`;
CREATE PROCEDURE  `cmn_select_class`()
begin   
    set @strsql1=concat('select p_cde cde,desc_cn name from t_common_cde where length(p_cde)=2');   
    prepare stmt1 from @strsql1;  
    execute stmt1;  
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_multi`;
CREATE PROCEDURE  `cmn_select_multi`( in par_cde varchar ( 200 ))
begin
    
    set @strsql1=concat('select c_cde cde,desc_cn name from t_common_cde where p_cde in',par_cde);
    
    prepare stmt1 from @strsql1;  
    execute stmt1;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_select_type`;
CREATE PROCEDURE  `cmn_select_type`( IN par_p_cde varCHAR ( 20 ))
BEGIN
          set @strSQL=concat('select p_cde,c_cde cde,desc_cn name
          from t_common_cde t where t.p_cde = ''',par_p_cde,'''',' order by desc_cn');
          prepare stmt from @strSQL;
          execute stmt;
          DEALLOCATE PREPARE stmt;



  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_tree`;
CREATE PROCEDURE  `cmn_tree`(IN par_c_cde CHAR(20), IN par_p_cde CHAR(20))
begin
declare v_level int unsigned default 0;

declare v_position int unsigned default 1;

declare v_row_count int unsigned default 0;

insert into tmp_cmn_tree(id,pid, level,position)
values (par_c_cde,par_p_cde,v_level,v_position);
set v_row_count := row_count();  
while v_row_count != 0 do
    set @position := 0;
    insert into tmp_cmn_tree(id,pid,level,position)
    select c.c_cde,c.p_cde
    , v_level + 1
    , @position := @position+1
    from t_common_cde c inner join tmp_cmn_tree t on c.p_cde = t.id 
    where t.level = v_level  order by c.c_cde;  
    set v_row_count := row_count();
    set v_level := v_level + 1;
end while;
select c.c_cde,c.p_cde,c.desc_cn from tmp_cmn_tree t left join t_common_cde c on t.pid=c.p_cde and t.id=c.c_cde;
truncate table tmp_cmn_tree;
 
  
end

DROP PROCEDURE IF EXISTS `cmn_update`;
CREATE PROCEDURE  `cmn_update`( in par_cde varchar (20),in par_desc varchar(255),IN par_update_user_id int(10))
begin
          set @strsql=concat('update t_common_cde set desc_cn=','''',par_desc,'''',',update_tm=sysdate(),update_user_id=','''',par_update_user_id,'''',' where c_cde =''',par_cde,'''');
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_update_category`;
CREATE PROCEDURE  `cmn_update_category`(IN par_c_cde VARCHAR(20), IN par_desc VARCHAR(255), IN par_update_user_id int(10))
begin       
    set @strsql=concat('update t_common_cde set desc_cn=','''',par_desc,'''',',',
        'update_user_id=',par_update_user_id,',',
        'update_tm=sysdate()',
        ' where c_cde=','''',par_c_cde,'''');
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `cmn_update_desc`;
CREATE PROCEDURE  `cmn_update_desc`(in par_cls_cde varchar(20),
IN par_cls_desc varchar(255),in par_cty_cde varchar(20),
IN par_cty_desc varchar(255))
begin     
   set @strsql=''; if par_cls_cde is not null and par_cls_desc is not null then
       set @strsql=concat(@strsql,'update t_common_cde set desc_cn=','''',par_cls_desc,'''',' where c_cde=','''',par_cls_cde,'''');

       prepare stmt from @strsql;  
       execute stmt;
       deallocate prepare stmt;
   end if;
   set @strsql='';

   if par_cty_cde is not null and par_cty_desc is not null then
       set @strsql=concat(@strsql,'update t_common_cde set desc_cn=','''',par_cty_desc,'''',' where c_cde=','''',par_cty_cde,'''');

       prepare stmt from @strsql;  
       execute stmt;
       deallocate prepare stmt;
   end if;
   
  
  
  
  
  
  
        
end



