DROP TABLE IF EXISTS `t_answer`;
CREATE TABLE `t_answer` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` int(5) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_answer` text NOT NULL,
  `create_tm` datetime NOT NULL,
  `create_user_id` int(10) NOT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`,`qsn_item_id`),
  KEY `Index_answer_qsn_type` (`qsn_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_answer_import`;
CREATE TABLE `t_answer_import` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` int(5) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_answer` text NOT NULL,
  `create_tm` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `create_user_id` int(10) NOT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`,`qsn_item_id`),
  KEY `Index_answer_qsn_type` (`qsn_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



