DROP PROCEDURE IF EXISTS `online_user_list`;
CREATE PROCEDURE  `online_user_list`(IN par_page_idx integer(10),IN par_page_size integer(10))
begin

 set @strsql=concat('
     select u.username,g.group_name,FROM_UNIXTIME(s.last_activity) active,u.login_count,
 u.last_login_tm,s.ip
     from t_session s join t_user u on u.user_id=s.user_id
     join t_user_group ug on ug.user_id=s.user_id
     join t_group g on g.group_id=ug.group_id
  where
    not exists(select aa.username from t_admin aa where aa.user_id=s.user_id)
union
 select a.username,g.group_name,FROM_UNIXTIME(s.last_activity) active,a.login_count,
 a.last_login_tm,s.ip
     from t_session s
     join t_user_group ug on ug.user_id=s.user_id
     join t_group g on g.group_id=ug.group_id
   join t_admin a on a.user_id=s.user_id');

 set @strsql=concat(@strsql,' union
     select \'Guest\' username,\'\' group_name,
   from_unixtime(s.last_activity) active,\'\' login_count,
   \'\' last_login_tm,s.ip
     from t_session s where not exists(select aa.username from t_user aa where aa.user_id=s.user_id)');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end



