DROP PROCEDURE IF EXISTS `role_delete`;
CREATE PROCEDURE  `role_delete`(in par_role_id varchar(2000))
begin
     
    set @strsql='';
    set @strsql=concat(@strsql,' delete from t_role where role_id in (',par_role_id,')');
    
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_insert`;
CREATE PROCEDURE  `role_insert`(in par_role_name varchar(100),
in par_role_value text,in par_role_desc varchar(200),IN par_create_user_id int(10))
begin
    
    insert into t_role(role_name,role_value,role_desc,create_tm,create_user_id)
    values(par_role_name,par_role_value,par_role_desc,sysdate(),par_create_user_id);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_select`;
CREATE PROCEDURE  `role_select`(in par_role_name varchar(100),
in par_role_desc varchar(200),in par_page_idx int(10),in par_page_size int(10))
begin

    set @strsql='select a.role_id,a.role_name,a.role_desc,a.create_tm from t_role a ';

    if par_role_name is not null or par_role_desc is not null  then
        set @strsql=concat(@strsql,' where ');

        if par_role_name is not null then
            set @strsql=concat(@strsql,' a.role_name like ','''',par_role_name,'%''');
            if par_role_desc is not null then
                set @strsql=concat(@strsql,' and a.role_desc like ','''',par_role_desc,'%''');
            end if;
        else
            if par_role_desc is not null then
                set @strsql=concat(@strsql,' a.role_desc like ','''',par_role_desc,'%''');
            end if;
        end if;
    end if;

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_select_info`;
CREATE PROCEDURE  `role_select_info`(in par_role_id int(10))
begin
    
    set @strsql='';
    set @strsql=concat(@strsql,'select role_id,role_name,role_value,role_desc,create_tm from t_role where role_id=',
                                '''',par_role_id,'''');
    
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_select_module`;
CREATE PROCEDURE  `role_select_module`()
begin     
    select t.p_cde,t.c_cde,t.desc_cn,t1.desc_cn p_des from t_common_cde t
    join (select c.desc_cn,c.c_cde from t_common_cde c where c_cde like '06%') t1
    on t1.c_cde=t.p_cde
    where t.c_cde like '06%' and length(t.c_cde) =6
    group by desc_cn order by t.c_cde;
         
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_select_module_name`;
CREATE PROCEDURE  `role_select_module_name`()
begin     
    SELECT t.p_cde,t.c_cde,t.desc_cn FROM t_common_cde t where t.c_cde like '06%' and length(t.c_cde)=4
    group by desc_cn order by t.desc_cn;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `role_update`;
CREATE PROCEDURE  `role_update`(in par_role_id int(10),in par_role_name varchar(100),
in par_role_desc varchar(200),in par_role_value text,IN par_update_user_id int(10))
begin
  if par_role_desc is not null then
    set @strsql=concat('update t_role set role_name=','''',par_role_name,'''',
  ',role_value=','''',par_role_value,'''',',role_desc=','''',par_role_desc,'''',
  ',update_user_id=',par_update_user_id,',update_tm=sysdate() where role_id=',par_role_id);
  else
    set @strsql=concat('update t_role set role_name=','''',par_role_name,'''',
    ',role_value=','''',par_role_value,'''',',role_desc=null',
    ',update_user_id=',par_update_user_id,',update_tm=sysdate() where role_id=',par_role_id);
  end if;prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end



