DROP TABLE IF EXISTS `tmp_exam_analysis_scoring_group_tree`;
CREATE TABLE `tmp_exam_analysis_scoring_group_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_e_a_s_g_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_analysis_user_scoring_tree`;
CREATE TABLE `tmp_exam_analysis_user_scoring_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_e_a_u_s_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_group_tree`;
CREATE TABLE `tmp_exam_group_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_e_g_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_papr_answer`;
CREATE TABLE `tmp_exam_papr_answer` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_papr_group_tree`;
CREATE TABLE `tmp_exam_papr_group_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_e_p_g_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_select_mark_info_tree`;
CREATE TABLE `tmp_exam_select_mark_info_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tmp_exam_select_mark_question_tree`;
CREATE TABLE `tmp_exam_select_mark_question_tree` (
  `pk` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `pid` char(32) DEFAULT NULL,
  `level` int(10) unsigned DEFAULT NULL,
  `position` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`pk`),
  KEY `t_e_s_m_q_tree` (`id`,`pid`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;



