DROP TABLE IF EXISTS `t_exam_papr_answer`;
CREATE TABLE  `t_exam_papr_answer` (
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` int(10) NOT NULL,
  `qsn_item_count` int(10) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) unsigned NOT NULL,
  `qsn_position` int(10) unsigned NOT NULL,
  `qsn_point` float NOT NULL,
  `qsn_answer` text NOT NULL,
  `create_tm` datetime DEFAULT NULL,
  `create_user_id` int(10) DEFAULT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`papr_id`,`qsn_id`,`qsn_sub_id`,`qsn_item_id`) USING BTREE,
  KEY `exam_papr_answer_idx` (`exam_id`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;