DROP TABLE IF EXISTS `t_user`;
CREATE TABLE  `t_user` (
  `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id2` varchar(50) DEFAULT NULL,
  `username` varchar(20) DEFAULT NULL,
  `nickname` varchar(100) DEFAULT NULL,
  `real_name` varchar(100) DEFAULT NULL,
  `pwd` varchar(50) DEFAULT NULL,
  `email` varchar(50) DEFAULT NULL,
  `status` varchar(10) DEFAULT '070101',
  `icon` varchar(255) DEFAULT NULL,
  `introduction` varchar(500) DEFAULT NULL,
  `gender` tinyint(1) unsigned DEFAULT NULL,
  `birthday` date DEFAULT NULL,
  `idcard` varchar(30) DEFAULT NULL,
  `examcard` varchar(30) DEFAULT NULL,
  `tel` varchar(30) DEFAULT NULL,
  `mobiletel` varchar(30) DEFAULT NULL,
  `position` varchar(30) DEFAULT NULL,
  `reg_ip` varchar(15) DEFAULT NULL,
  `reg_tm` datetime DEFAULT NULL,
  `update_tm` datetime DEFAULT NULL,
  `login_count` int(10) unsigned DEFAULT NULL,
  `last_login_tm` datetime DEFAULT NULL,
  `last_login_ip` varchar(15) DEFAULT NULL,
  `study_point` int(4) unsigned DEFAULT '0',
  `study_day_answer_point` int(4) unsigned DEFAULT '0',
  PRIMARY KEY (`user_id`),
  KEY `idx_username` (`username`),
  KEY `Idx_email` (`email`),
  KEY `idx_idcard` (`idcard`),
  KEY `idx_examcard` (`examcard`)
) ENGINE=InnoDB AUTO_INCREMENT=72 DEFAULT CHARSET=utf8;