DROP TABLE IF EXISTS `t_user_exam_storage`;
CREATE TABLE  `t_user_exam_storage` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `exam_tm` datetime DEFAULT NULL,
  `user_exam_scoring` float DEFAULT NULL,
  `exam_point` float DEFAULT NULL,
  `exam_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`user_id`,`exam_times`,`papr_id`),
  KEY `Index_u_exam_storage` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;