DROP TABLE IF EXISTS `t_user_homework`;
CREATE TABLE  `t_user_homework` (
  `homework_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `homework_times` smallint(6) NOT NULL,
  `homework_tm` datetime NOT NULL,
  `user_homework_scoring` float NOT NULL,
  `homework_point` float DEFAULT NULL,
  `homework_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`homework_id`,`user_id`,`homework_times`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;