DROP TABLE IF EXISTS `t_user_homework_info`;
CREATE TABLE  `t_user_homework_info` (
  `user_id` int(10) NOT NULL,
  `homework_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `homework_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `answer_status` char(1) NOT NULL,
  `scoring` float DEFAULT NULL,
  `remark` varchar(4000) DEFAULT NULL,
  `marker_id` int(10) DEFAULT NULL,
  `mark_tm` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`,`papr_id`,`homework_id`,`homework_times`,`qsn_id`,`qsn_sub_id`),
  KEY `Index_homework_info_type` (`qsn_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;